-- # import Property

-- Lattice theory, from Dijkstra

D : Set
(<=) : D -> D -> Prop
meet : D -> D -> D
sup : D -> D -> D

infix 6 <=

trans : (x:D) -> (y:D) -> (z:D) -> x <= y ==> y <= z ==> x <= z

ref  : (x : D) -> (y:D) -> (x <= y /\ y <= x   <=>   x == y)
axM : (x : D) -> (y : D) -> (z : D) ->
           ( z <= meet x y    <=>
         z <= x /\ z <= y
           )
axS : (x : D) -> (y : D) -> (z : D) ->
           ( sup x y    <= z <=>
         x <= z /\ y <= z
           )

-- paradox finds one of the two 5 element counter models (with --fol-no-binary-app)
distr : (x:D) -> (y:D) -> (z:D) -> meet x (sup y z) == sup (meet x y) (meet x z)
distr x y z = fol-plugin(axM,axS,ref,trans)

