-- # import Property

-- some logical axioms

Obj : Set
(-->) : Obj -> Obj -> Set

id (a : Obj) : a --> a
(@) (a, b, c : Obj) : a --> b -> b --> c -> a --> c
infix 15 @

axId1 (a, b : Obj) : (f : a --> b) -> f == id @ f
axId2 (a, b : Obj) : (f : a --> b) -> f == f @ id

assoc (a, b, c, d : Obj) :
      (f:a --> b) -> (g:b --> c) -> (h:c --> d) ->
      (f @ g) @ h == f @ (g @ h)

isMono (a, b : Obj) : a --> b -> Prop
isMono {a} f =
  (c : Obj) -> (g, h : c --> a) ->
  g @ f == h @ f ==> g == h

a:Obj
b:Obj
c:Obj
k:a --> b
f:b --> c

prop : isMono (k @ f) ==> isMono k
-- prop monkf d g h hEq =
--  fol-plugin(assoc,hEq,monkf)
prop = impI (\ monkf -> fol-plugin(assoc,monkf))

prop1 : isMono (k @ f) -> (d:Obj) -> (g,h:d --> a) -> 
        g @ k == h @ k -> g == h
prop1 monkf d g h hEq =
 let 
  rem1 : g @ (k @ f) == h @ (k @ f)
  rem1 =  fol-plugin(assoc,hEq)
  rem2 : g == h
  rem2 =  fol-plugin(rem1,monkf)
 in
  rem2

